searchNodes=[{"doc":"Bandit is an HTTP server for Plug apps. As an HTTP server, Bandit's primary goal is to act as 'glue' between client connections managed by Thousand Island and application code defined via the Plug API . As such there really isn't a whole lot of user-visible surface area to Bandit, and as a consequence the API documentation presented here is somewhat sparse. This is by design! Bandit is intended to 'just work' in almost all cases; the only thought users typically have to put into Bandit comes in the choice of which options (if any) they would like to change when starting a Bandit server. The sparseness of the Bandit API should not be taken as an indicator of the comprehensiveness or robustness of the project. Basic Usage Usage of Bandit is very straightforward. Assuming you have a Plug module implemented already, you can host it within Bandit by adding something similar to the following to your application's Application.start/2 function: def start ( _type , _args ) do children = [ { Bandit , plug : MyApp.MyPlug , scheme : :http , options : [ port : 4000 ] } ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end Writing Plug Applications For details about writing Plug based applications, consult the excellent Plug documentation for plenty of examples &amp; tips to get started. Note that while Bandit supports the complete Plug API &amp; should work correctly with any Plug-based application you may write, it does not currently support Phoenix applications due to our lack of support for WebSocket connections. Early support for Phoenix will be coming to Bandit in the 0.4.x release series (likely Q4'21), with full support landing in the 0.7.x release series (likely Q1'22). Config Options Bandit takes a number of options at startup: plug : The plug to handle connections. Can be specified as MyPlug or {MyPlug, plug_opts} scheme : One of :http or :https . If :https is specified, you will need to specify certfile and keyfile in the transport_options subsection of options . read_timeout : How long to wait for data from the client before timing out and closing the connection, specified in milliseconds. Defaults to 60_000 options : Options to pass to ThousandIsland . For an exhaustive list of options see the ThousandIsland documentation, however some common options are: port : The port to bind to. Defaults to 4000 num_acceptors : The number of acceptor processes to run. This is mostly a performance tuning knob and can usually be left at the default value of 10 transport_module : The name of the module which provides basic socket functions. This overrides any value set for scheme and is intended for cases where control over the socket at a fundamental level is needed. transport_options : A keyword list of options to be passed into the transport socket's listen function Setting up an HTTPS Server By far the most common stumbling block encountered with configuration involves setting up an HTTPS server. Bandit is comparatively easy to set up in this regard, with a working example looking similar to the following: def start ( _type , _args ) do bandit_options = [ port : 4000 , transport_options : [ certfile : Path . join ( __DIR__ , &quot;path/to/cert.pem&quot; ) , keyfile : Path . join ( __DIR__ , &quot;path/to/key.pem&quot; ) ] ] children = [ { Bandit , plug : MyApp.MyPlug , scheme : :https , options : bandit_options } ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end","ref":"Bandit.html","title":"Bandit","type":"module"},{"doc":"","ref":"Bandit.html#child_spec/1","title":"Bandit.child_spec/1","type":"function"},{"doc":"","ref":"Bandit.html#start_link/1","title":"Bandit.start_link/1","type":"function"},{"doc":"A Plug definition","ref":"Bandit.html#t:plug/0","title":"Bandit.plug/0","type":"type"},{"doc":"Raised by Bandit adapters if a body is attempted to be read more than once per request","ref":"Bandit.BodyAlreadyReadError.html","title":"Bandit.BodyAlreadyReadError","type":"exception"}]